alias zeneth.get.getlist {
  if ($dialog( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ).x == $null) { zeneth.get.open $1 }
  else { dialog -v [ zeneth-Getlist- [ $+ [ $1 ] ] ] }
  zeneth.get.loadinfo $1
}
alias zeneth.get.loadinfo {
  var %zeneth.lines = $lines( [ $zeneth.getdir($1) ] )
  did -r zeneth-Getlist- $+ $1 9
  %zeneth.tsize. [ $+ [ $1 ] ] = 0
  if ((%zeneth.lines == 0) || (%zeneth.lines == $null)) { var %zeneth.line = 0 | goto end }
  var %zeneth.line = 1
  :loop
  zeneth.get.add $1 $read -nl $+ %zeneth.line [ $zeneth.getdir($1) ]
  if (%zeneth.line >= %zeneth.lines ) { goto end }
  else { inc %zeneth.line 1 | goto loop }
  :end
  if (%zeneth.lines == $null) { var %zeneth.lines = 0 }
  did -o zeneth-Getlist- [ $+ [ $1 ] ] 7 1 Total Files: %zeneth.lines
  did -o zeneth-Getlist- [ $+ [ $1 ] ] 8 1 Total Size: %zeneth.tsize. [ $+ [ $1 ] ] Bytes - $zeneth.sconvert( [ %zeneth.tsize. [ $+ [ $1 ] ] ] )
  zeneth.exp.ref zeneth-Exp- [ $+ [ $1 ] ] lookup tagged
}
alias zeneth.get.add {
  did -a zeneth-Getlist- [ $+ [ $1 ] ] 9 [ $zeneth.repcomr($zeneth.repdb($remove($2-, [ $zeneth.seperate($2-) $+ b ] ))) ] $str($chr(160),20) $zeneth.seperate($2-) Bytes ( $+ $zeneth.convert($zeneth.seperate($2-)) $+ )
  %zeneth.tsize. [ $+ [ $1 ] ] = $calc( [ %zeneth.tsize. [ $+ [ $1 ] ] ] + [ $zeneth.seperate($2-) ] )
}
alias zeneth.get.open { dialog -m zeneth-Getlist- [ $+ [ $1 ] ] zeneth-Getlist }
dialog Zeneth-Getlist {
  title "Getlist"
  size 32 12 526 287.5
  menu  "&File" 1
  menu "&Move" 2
  item "&Top of List",10
  item "&Position",11
  item "&End of List",12
  button "&Refresh",4,2.5 245 520 20
  menu "&Delete" 5
  item "&Selection",13
  menu "&All Files",14,5
  item "&Do it!",15
  menu "&Help" 3
  text "Total Files: 0",7,145 5 90 20
  text "Total Size: 0",8,235 5 185 20
  list 9,2.5 25 520 220, extsel
  button "HIDDEN",100,1 1 1 1,cancel,hide
}
on *:dialog:zeneth-Getlist-*:init:0:{
  dialog -t $dname $zeneth.titlebar(Getlist for: [ $zeneth.get.getli ] )
  zeneth.exp.filemenu $dname 1
  zeneth.exp.helpmenu $dname 3
}
on *:dialog:zeneth-Getlist-*:menu:133:dialog -x $dname
on *:dialog:zeneth-Getlist-*:menu:96:zeneth.hlp Zeneth
on *:dialog:zeneth-Getlist-*:menu:98:zeneth.about
on *:dialog:zeneth-Getlist-*:menu:10:zeneth.get.move $zeneth.get.getli 1
on *:dialog:zeneth-Getlist-*:menu:11:zeneth.exp.cmd zeneth.get.move $zeneth.get.getli $!$?="Position?"
on *:dialog:zeneth-Getlist-*:menu:12:zeneth.get.move $zeneth.get.getli END
on *:dialog:zeneth-Getlist-*:menu:13:zeneth.get.delete $zeneth.get.getli
on *:dialog:zeneth-Getlist-*:menu:15:zeneth.get.clear $zeneth.get.getli
on *:dialog:zeneth-Getlist-*:sclick:4:zeneth.get.loadinfo $zeneth.get.getli
alias zeneth.get.getli { return $right($dname,-15) }
alias zeneth.get.getlis { return $right($1,-15) }
alias zeneth.get.move {
  var %zeneth.movefile = [ $zeneth.getdir($1) ]
  var %zeneth.lines = [ $lines( [ %zeneth.movefile ] ) ]
  if ($2 == END) { var %zeneth.position = %zeneth.lines }
  else { var %zeneth.position = $2 }
  if ((%zeneth.position !isnum) || (%zeneth.position > %zeneth.lines )) { halt }
  var %zeneth.lopget = $did( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ,9,0).sel
  var %zeneth.getlop = 1
  if (%zeneth.lopget == $null) { halt }
  :getlop
  if (%zeneth.getlop > %zeneth.lopget ) { goto done }
  else {
    var %zeneth.ln = [ $did( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ,9,%zeneth.getlop).sel ]
    var %zeneth.calc.getlop = 0
    dec %zeneth.calc.getlop [ $calc(%zeneth.getlop - 1) ] 
    if ((%zeneth.ln <= %zeneth.position ) && (%zeneth.calc.getlop < 0)) { inc %zeneth.ln %zeneth.calc.getlop }
    var %zeneth.txt = $read -nl $+ [ %zeneth.ln ] [ %zeneth.movefile ]
    if (%zeneth.txt == $null) { goto skipp }
    write -dl $+ [ %zeneth.ln ] [ %zeneth.movefile ]
    write -il $+ [ %zeneth.position ] [ %zeneth.movefile ] %zeneth.txt
    :skipp
    inc %zeneth.getlop 1
    goto getlop
  }
  :done
  zeneth.get.getlist $1
  zeneth.credref $1
}
alias zeneth.get.delete {
  var %zeneth.getlop = 1 
  var %zeneth.lopget = $did( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ,9,0).sel
  if (%zeneth.lopget == $null) { halt }
  :getlop
  if (%zeneth.getlop > %zeneth.lopget) { goto done }
  else {
    var %zeneth.ln = $did( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ,9, [ %zeneth.getlop ] ).sel
    dec %zeneth.ln [ $calc(%zeneth.getlop - 1) ]
    write -dl $+ %zeneth.ln [ $zeneth.getdir($1) ]
    inc %zeneth.getlop 1
    goto getlop
  }
  :done
  .timer.zeneth.getdel. [ $+ [ $1 ] ] 1 1 zeneth.credref $1
  zeneth.get.getlist $1
}
alias zeneth.get.clear {
  write -c [ $zeneth.getdir($1) ]
  .timer.zeneth.refcred 1 1 zeneth.credref $1
  if ( [ $dialog( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ).x ] != $null) { zeneth.get.getlist $1 }
}
alias zeneth.repcom { return $replace($1-,$chr(44),) }
alias zeneth.repcomr { return $replace($1-,,$chr(44)) }
alias zeneth.getf { return [ $zeneth.getff( [ $replace($zeneth.repb($zeneth.repcom($1-)),$chr(32), [ $chr(32) $+ $chr(44) $+ $chr(32) ] ) ] ) ] }
alias zeneth.getff { return $2- }
alias zeneth.credlow {
  if ( [ $zeneth.r.asend($1) ] != off) { zeneth.exp.autosend $1 }
  else { zeneth.exp.status $zeneth.exp.dialog($1) Unable to get the requested files due to lack of credit! }
}
alias zeneth.getfail {
  if ($dialog( [ zeneth-Getfail- $+ [ $1 ] ] ).x == $null) { zeneth.fail.open $1 }
  else { dialog -v [ zeneth-Getfail- $+ [ $1 ] ] }
  zeneth.fail.getfail $1
}
alias zeneth.fail.getfail {
  did -r [ zeneth-Getfail- $+ [ $1 ] ] 8
  flash <<<ZeNeTh FileServer Explorer>>> Failed to Get file from $1 <<<ZeNeTh FileServer Explorer>>> 
  unset %zeneth.ia*
  var %zeneth.iad = 1
  var %zeneth.iadd = $lines( [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai ] )
  did -o [ zeneth-Getfail- $+ [ $1 ] ] 7 1 Total Files: [ %zeneth.iadd ]
  if ((%zeneth.iadd == 0) || (%zeneth.iadd == $null)) { goto end }
  :loop
  zeneth.fail.add $1 $read -l $+ %zeneth.iad %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai 
  if (%zeneth.iad >= %zeneth.iadd ) { goto end }
  inc %zeneth.iad 1
  goto loop
  :end
  unset %zeneth.ia*
}
alias zeneth.fail.total { 
  var %zeneth.tot =  $lines( [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai ] ) 
  if (%zeneth.tot == $null) { return 0 }
  else { return %zeneth.tot }
}
alias zeneth.fail.add { did -a [ zeneth-Getfail- $+ [ $1 ] ] 8 $2 $str($chr(160),29) $4 $str($chr(160),29) $remove($3,b) Bytes ( $+ [ $zeneth.convert( [ $remove($3,b) ] ) ] $+ ) }
alias zeneth.fail.open { dialog -m zeneth-Getfail- [ $+ [ $1 ] ] zeneth-Getfail }
dialog Zeneth-Getfail {
  title "Getfail"
  size 32 12 526 280
  menu "&File",1
  item "&Get File + Change",12
  item break,13
  item "&Close Window",133
  button "&Refresh",4,2.5 240 520 20
  menu "&Get",10
  item "&Selected",14
  item "&All Files",15
  menu "&Delete",5
  item "&Selected",16
  menu "&All Files",17,5
  item "&Do it!",18
  text "Total Files: 0",7,215 5 90 20
  list 8,2.5 25 520 220, extsel
  menu "&Help",3
  button "HIDDEN",11,1 1 1 1,cancel,hide
}
on *:dialog:zeneth-GetFail-*:init:0:{
  dialog -t $dname $zeneth.titlebar(Failed Files for: [ $zeneth.fail.getfai ] )
  zeneth.exp.helpmenu $dname 3
}
on *:dialog:zeneth-GetFail-*:menu:133:dialog -x $dname
on *:dialog:zeneth-GetFail-*:menu:12:zeneth.fail.get $zeneth.fail.getfai Change
on *:dialog:zeneth-GetFail-*:menu:14:zeneth.fail.getmultiple $zeneth.fail.getfai
on *:dialog:zeneth-GetFail-*:menu:15:zeneth.fail.getmultiple $zeneth.fail.getfai all
on *:dialog:zeneth-GetFail-*:menu:16:zeneth.fail.remove $zeneth.fail.getfai
on *:dialog:zeneth-GetFail-*:menu:18:zeneth.fail.clear $zeneth.fail.getfai
on *:dialog:zeneth-GetFail-*:sclick:4:zeneth.getfail $zeneth.fail.getfai
on *:dialog:zeneth-GetFail-*:dclick:8:zeneth.fail.getmultiple $zeneth.fail.getfai
on *:dialog:zeneth-GetFail-*:menu:96:zeneth.hlp Zeneth
on *:dialog:zeneth-GetFail-*:menu:98:zeneth.about
alias zeneth.fail.getfai { return $right($dname,-15) }
alias zeneth.fail.getfail { return $right($1,-15) }
alias zeneth.fail.clear {
  var %zeneth.dirrr = %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai
  write -c %zeneth.dirrr
  zeneth.getfail $1
}
alias zeneth.fail.remove {
  var %zeneth.getlop = 1
  var %zeneth.lopget = $did($dname,8,0).sel
  if (%zeneth.lopget == $null) { halt }
  :getlop
  if (%zeneth.getlop > %zeneth.lopget) { goto done }
  else {
    var %zeneth.ln = $did($dname,8, [ %zeneth.getlop ] ).sel
    dec %zeneth.ln [ $calc(%zeneth.getlop - 1) ]
    if (%zeneth.ln <= 0) { goto fsn }
    write -dl $+ %zeneth.ln %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai
    :fsn
    inc %zeneth.getlop 1
    goto getlop
  }
  :done
  zeneth.getfail $1
}
alias zeneth.fail.get {
  var %zeneth.gline = [ $did($dname,8,1).sel ]
  if (%zeneth.gline <= 0) { halt }
  zeneth.fail.Getfile $1 $2 $read -l $+ %zeneth.gline %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai
}
alias zeneth.fail.getfile {
  .timer.zeneth.fail. [ $+ [ $1 ] ] 1 2 zeneth.getfail $1
  .timer.zeneth.gett. [ $+ [ $1 ] ] 1 10 zeneth.getstuff $1
  if ( [ $dialog(zeneth-Getlist- [ $+ [ $1 ] ] ).x ] != $null) { .timer.zeneth.get1. [ $+ [ $1 ] ] 1 10 zeneth.getlist $1 }
  if ($2 == change) { zeneth.exp.cmd zeneth.exp.path $1 $5- }
  if ($2 != norm) { write -ds $+ [ $zeneth.rep1($3) ] %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai }
  write -ds $+ [ $zeneth.rep3($zeneth.rep1($3)) ] %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir($5-)) ] $+ .get
  write %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir($5-)) ] $+ .get $zeneth.rep3($3) [ $4 ]
  write %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fle $zeneth.rep3($3) [ $4 ] $5
  zeneth.refcred $1
}
alias zeneth.fail.getmultiple {
  if ($2 == all) { var %zeneth.fail.total = $lines( [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai ] ) }
  else { var %zeneth.fail.total = $did( [ zeneth-Getfail- [ $+ [ $1 ] ] ] ,8,0).sel }
  var %zeneth.fail.loop = 1
  if ($2 == all) { var %zeneth.fail.line = 1 }
  :loop
  if (%zeneth.fail.loop > %zeneth.fail.total ) { goto end }
  if ($2 != all) { var %zeneth.fail.line = $did( [ zeneth-Getfail- [ $+ [ $1 ] ] ] ,8,%zeneth.fail.loop ).sel |   dec %zeneth.fail.line [ $calc( [ %zeneth.fail.loop ] - 1) ] }
  .timer.zeneth.fail.multi. [ $+ [ $1 ] ] [ $+ [ %zeneth.fail.loop ] ] 1 0 zeneth.fail.getfile $1 Norm $read -l $+ %zeneth.fail.line %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai
  write -dl $+ [ %zeneth.fail.line ] %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai
  inc %zeneth.fail.loop 1
  goto loop
  :end
  if ($dialog(zeneth-GetFail- [ $+ [ $1 ] ] ).x != $null) { zeneth.getfail $1 }
}
alias zeneth.failed {
  if ( [ $zeneth.r.fserv($1) ] == $null) { halt }
  var %zeneth.getfail = $read -ns $+ $zeneth.rep3($nopath($2-)) [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fle ] 
  write -ds [ $+ [ $zeneth.rep3($nopath($2-)) ] ] %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fle
  write %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .fai $zeneth.rep3($nopath($2-)) [ $zeneth.d1(%zeneth.getfail) ] [ $zeneth.d2(%zeneth.getfail) ] 
  if (%zeneth.getfail != $null) { zeneth.getfail $1 }
  unset %zeneth.timechk [ $+ [ $1 ] ]
  .timer.zeneth.gett $+ $nick 1 4 zeneth.getstuff $1
}
alias zeneth.read.open { dialog -m zeneth-Read- [ $+ [ $1 ] ] zeneth-Read }
dialog Zeneth-Read {
  title "ZeNeTh-Read"
  size 22 12 360 350
  menu "&File",1
  item "&Save...",11
  item break,12
  item "&Close Window",133
  menu "&Help",2
  button "&Get Next Part of File",3,115 0 132.5 20
  button "&Download File!",4,2.5 307.5 355 20
  edit "",5,2.5 50 355 252.5,multi,read,hsbar,vsbar,limit 9999999999999
  text "Filename:",6,30 30 200 20
  text "Size:",7,200 30 100 20
  text "Reading File...",8,143 162 100 20
  button "HIDDEN",9,1 1 1 1,cancel,hide
}
on *:dialog:zeneth-Read-*:init:0:{ zeneth.exp.helpmenu $dname 2 }
on *:dialog:zeneth-Read-*:menu:133:dialog -x $dname
on *:dialog:zeneth-Read-*:menu:11:zeneth.exp.cmd zeneth.read.save $zeneth.rea
on *:dialog:zeneth-Read-*:menu:96:zeneth.hlp Zeneth
on *:dialog:zeneth-Read-*:menu:98:zeneth.about
on *:dialog:zeneth-Read-*:sclick:3:zeneth.read.request $zeneth.rea
on *:dialog:zeneth-Read-*:sclick:4:zeneth.read.download $zeneth.rea
alias zeneth.read.read {
  if ($did($2,36,0).sel == 0) { halt }
  var %zeneth.helpe = $did($2,36,1).sel
  var %zeneth.mmask = $zeneth.r.mask($1)
  if (%zeneth.mmask != *.*) { var %zeneth.Explorer = $read -nl $+ %zeneth.helpe %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .msk }
  else { var %zeneth.Explorer = $read -nl $+ %zeneth.helpe [ $zeneth.repcom($zeneth.rep3( [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ $+ - $+ [ $zeneth.repcom($zeneth.repdir($zeneth.rep3($zeneth.curdir($1)))) ] ] )) ] }
  if ($dialog(zeneth-Read- [ $+ [ $1 ] ] ).x == $null) { zeneth.read.open $1 }
  zeneth.read.startread $1 [ $right(%zeneth.Explorer , [ $calc( [ $len(%zeneth.Explorer) - 1 ] ) ] ) ]
}
alias zeneth.read.startread {
  did -r $zeneth.read.dlg($1) 5
  var %zeneth.reading = [ $remove($2-, [ $zeneth.seperate($2-) $+ b ] ) ]
  zeneth.writeini [ $1 ] Reading %zeneth.reading
  var %zeneth.getsize = [ $zeneth.seperate( $2- ) $+ b ]
  zeneth.writeini [ $1 ] Getsize %zeneth.getsize
  zeneth.writeini [ $1 ] Getpath [ $zeneth.curdir($1) ] 
  zeneth.writeini [ $1 ] Status Read
  var %zeneth.chk = 0
  .msg = $+ $1 read -50 [ $zeneth.r.reading($1) ]
  dialog -t $zeneth.read.dlg($1) Reading: [ $zeneth.r.reading($1) ]
  did -h $zeneth.read.dlg($1) 5
  did -vo $zeneth.read.dlg($1) 6 1 Filename: [ $zeneth.r.reading($1) ]
  did -vo $zeneth.read.dlg($1) 7 1 Size: [ $zeneth.r.getsize($1) ]
  did -v $zeneth.read.dlg($1) 8
}
alias zeneth.stopread {
  if ($zeneth.r.status($1) != Read) { halt }
  if ($2 == er) {  zeneth.msg Read- [ $+ [ $1 ] ] e I'm sorry, but to view the rest of the file you will have to DOWNLOAD it! | goto disableget }
  var %zeneth.name = [ $zeneth.read.dlg($1) ]
  did -v %zeneth.name 5
  did -h %zeneth.name 8
  if ($2 == fin) { did -a %zeneth.name 5 <<End of File>> | goto disableget }
  var %zeneth.ver = $zeneth.r.fserv($1)
  if ((Panzer isin %zeneth.ver) || (sphoo isin %zeneth.ver)) { goto disableget }
  goto end
  :disableget
  did -b %zeneth.name 3
  :end
  zeneth.writeini $1 Status Norm
}
alias zeneth.read.add { did -a zeneth-Read- [ $+ [ $1 ] ] 5 $2- $crlf }
alias zeneth.read.dlg { return zeneth-Read- [ $+ [ $1 ] ] }
alias zeneth.rea { return $right($dname,-12) }
alias zeneth.rchek {
  var %zeneth.rchek = $1-
  var %zeneth.rchek = [ $right(%zeneth.rchek,3) ] 
  if ((%zeneth.rchek == txt) || (%zeneth.rchek == doc) || (%zeneth.rchek == diz) || (%zeneth.rchek == nfo) || (%zeneth.rchek == mrc) || (%zeneth.rchek == ini)) { return y }
  else { return n }
}
alias zeneth.read.request {
  zeneth.writeini $1 Status read
  .msg = $+ $1 c
}
alias zeneth.read.download {
  var %zeneth.writedir = %zeneth.dir $+ $zeneth.rep1($1) $+ - $+ [ $zeneth.repcom($zeneth.repdir($zeneth.r.getpath($1))) ] $+ .get
  write -ds $+ [ $zeneth.rep3($zeneth.rep1($zeneth.r.reading($1))) ] %zeneth.writedir
  write %zeneth.writedir [ $zeneth.rep3($zeneth.rep1($zeneth.r.reading($1))) ] [ $zeneth.r.getsize($1) ]
}
alias zeneth.read.save {
  dialog -v zeneth-Read- [ $+ [ $1 ] ]
  var %zeneth.savdir = $$sdir="Select a Destination Directory"
  var %zeneth.savnam = $zeneth.r.reading($1)
  var %zeneth.savsize = [ $remove( [ $zeneth.r.getsize($1) ] , [ $right( [ $zeneth.r.getsize($1) ] ,1) ] ) ]
  var %zeneth.save = [ " $+ [ [ %zeneth.savdir ] $+ [ %zeneth.savnam ] ] $+ " ]
  zeneth.savebuf zeneth-Read- [ $+ [ $1 ] ] 5 %zeneth.save
  write -il1 %zeneth.save +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+ $chr(10)
  write -il1 %zeneth.save Original Size: %zeneth.savsize Bytes ( $+ [ $zeneth.convert( [ %zeneth.savsize ) ] ] $+ )
  write -il1 %zeneth.save Original Filename: %zeneth.savnam 
  write -il1 %zeneth.save Downloaded From: $1 
  write -il1 %zeneth.save +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
  write -il1 %zeneth.save $zeneth.version
}
alias zeneth.savebuf {
  var %zeneth.l = 1
  var %zeneth.ltotal = $did($1,$2).lines
  var %zeneth.lsave = $3-
  if ($exists(%zeneth.lsave)) { if ($?!="Overwrite File?") { write -c %zeneth.lsave | goto loop } | else { halt } }
  :loop
  if (%zeneth.l > %zeneth.ltotal ) { goto end }
  write -a %zeneth.lsave $did($1,$2, [ %zeneth.l ] ).text
  inc %zeneth.l 1
  goto loop
  :end
}
alias zeneth.loadbuf {
  var %zeneth.l = 1
  var %zeneth.ltotal = $lines($3-)
  if (%zeneth.ltotal < 1) { goto end }
  :loop
  if (%zeneth.l > %zeneth.ltotal) { goto end }
  did -a $1 $2 $read -nl [ $+ [ %zeneth.l ] ] [ $3- ]
  inc %zeneth.l 1
  goto loop
  :end
}
alias zeneth.exp.ref.all {
  zeneth.exp.ref $1 Credit
  zeneth.exp.ref $1 Ratio
  zeneth.exp.ref $1 MaxGets
  zeneth.exp.ref $1 MaxSends
  zeneth.exp.ref $1 Dir Files
  zeneth.exp.ref $1 Dir Dirs
  zeneth.exp.ref $1 Mask
  zeneth.exp.ref $1 Asend
  zeneth.exp.ref $1 CurrentDir
  zeneth.exp.ref $1 AsendCredit
  zeneth.exp.ref $1 Failed
  zeneth.exp.ref $1 Lookup Path
  zeneth.exp.ref $1 Lookup AsendNo
  zeneth.exp.ref $1 Lookup Dup
  zeneth.exp.ref $1 Lookup Tagged
}
alias zeneth.credit.conv {
  var %zeneth.d = $zeneth.exp.dialog($1)
  if ($dialog(%zeneth.d).x  == $null) { halt }
  if ($zeneth.r.creditconv($1) != Yes) { zeneth.writeini $1 CreditConv Yes | did -a %zeneth.d $2 $zeneth.sconvert($zeneth.r.credit($1)) }
  else { zeneth.writeini $1 CreditConv No | did -a %zeneth.d $2 $zeneth.r.credit($1) }
}
alias zeneth.credit.ref {
  var %zeneth.d = $zeneth.exp.dialog($1)
  if ($dialog(%zeneth.d).x  == $null) { halt }
  if ($zeneth.r.creditconv($1) == Yes) { did -a %zeneth.d $2 $zeneth.sconvert($zeneth.r.credit($1)) }
  else { did -a %zeneth.d $2 $zeneth.r.credit($1) }
}
alias zeneth.mask.reset { zeneth.writeini $1 Mask *.* }
alias zeneth.dir.0b {
  if (($right($1-,2) == 0b) && ($left($1,2) != [ f $+ $chr(32) ] )) { return $left($1-,-2) }
  else { return $1- }
}
alias zeneth.readini {
  unset %zeneth.readini
  if ($1 != $zeneth.d) { set %zeneth.readini $readini %zeneth.dir $+ [ [ $zeneth.rep1($1) ] $+ .ini ] [ $zeneth.readread($1) ] $2 }
  else { set %zeneth.readini $readini %zeneth.dirr $+ zeneth.dat $1 $2 }
  set %zeneth.readini2 %zeneth.readini
  set %zeneth.readini $replace(%zeneth.readini2,$zeneth.readread($1),$1)
  return %zeneth.readini
}
alias zeneth.achat {
  if ( [ $zeneth.r.fchat($1) ] != yes) { halt }
  if ( [ $zeneth.r.factive($1) ] != on) {
    window -ne @ZeNeTh- $+ [ $1 ] @ZeNeTh-Chat
    aline @ZeNeTh- $+ [ $1 ] 4<2 $+ $nick $+ 4>12 $2-
  }
  else {
    var %zeneth.state = $window( [ @ZeNeTh- $+ [ $1 ] ] ).state
    if ((%zeneth.state == minimized) || (%zeneth.state == $null)) { window -ruae @ZeNeTh- $+ [ $1 ] %zeneth.xpos %zeneth.ypos 431 234 @ZeNeTh-chat }
    aline @ZeNeTh- $+ [ $1 ] 4<2 $+ [ $1 ] $+ 4>12 $2-
  }
}
alias zeneth.dirs {
  if (( [ $left( [ $right($1-,4) ] ,1) ] == .) && ($chr(32) isin $1-)) {
    if (. isin [ $left($remove($1-,$chr(32)),6) ] ) { return [ $remove($remove($1-,$chr(32)),$right($1-,4)) ] $+ ~1 $+ [ $right($1-,4) ] }
    else { if (2.3 isin [ $zeneth.r.fserv($1) ] ) { return [ $left( [ $remove($1-,$chr(32)) ] ,6) ] $+ ~1 $+ [ $right($1-,4) ] } | else { return $1- } }
    halt
  }
  if ($chr(32) isin $1-) { return [ $left( [ $remove($1-,$chr(32)) ] ,6) ] $+ ~1 }
  else { return $1- }
}
alias zeneth.read { return $zeneth.readini($1 , $2) }
alias zeneth.writeini {
  if ($1 != $zeneth.d) { writeini %zeneth.dir $+ [ [ $zeneth.rep1($1) ] $+ ] .ini [ $zeneth.readread($1) ] $2- }
  else { writeini %zeneth.dirr $+ zeneth.dat [ $1 ] $2- }
}
alias zeneth.readread { return $replace($replace($1,[,$chr(191)),],$chr(192)) }
alias zeneth.credit.mod {
  .timer.zeneth.creditmod. [ $+ [ $2 ] ] 1 3 .msg = $+ $2 credit
  if ($3 !isnum) { if ($3 == ALL) { var %zeneth.credit = $3 your credits } | else { var %zeneth.credit = Free Credit (Leech) Access } }
  else { var %zeneth.credit = $3 Bytes ( $+ [ $zeneth.sconvert($3) ] $+ ) }
  if ($1 == given) { var %zeneth.reason = You have just been GIVEN %zeneth.credit by the operator! }
  if ($1 == taken) { var %zeneth.reason = You have just had %zeneth.credit TAKEN by the operator }
  if ($1 == Reason) { zeneth.msg $2 2 Reason: $3- }
  else { zeneth.msg $2 1 %zeneth.reason }
}
alias zeneth.top.open {
  if ($dialog(zeneth-Top10- [ $+ [ $1 ] ] ).x == $null) { dialog -m zeneth-Top10- [ $+ [ $1 ] ] zeneth-Top10 }
  else { zeneth.top.view $1 zeneth-Top10- [ $+ [ $1 ] ] }
}
dialog Zeneth-Top10 {
  title "Top10"
  size 22 12 190 187.5
  list 1,5 5 180 137.5, size
  menu "&File",2
  menu "&Help",3
  button "&Get",4,5 145 180 20
  button "HIDDEN",5,1 1 1 1,cancel,hide
}
on *:dialog:zeneth-Top10-*:init:0:{
  zeneth.exp.filemenu $dname 2
  zeneth.exp.helpmenu $dname 3
  zeneth.top.view $right($dname,-13) $dname
}
on *:dialog:zeneth-Top10-*:menu:133:dialog -x $dname
on *:dialog:zeneth-Top10-*:menu:96:zeneth.hlp Zeneth
on *:dialog:zeneth-Top10-*:menu:98:zeneth.about
on *:dialog:zeneth-Top10-*:sclick:4:zeneth.top.get $right($dname,-13)
on *:dialog:zeneth-Top10-*:dclick:1:zeneth.top.get $right($dname,-13)
alias zeneth.top.get {
  var %zeneth.gettopnum = $did($dname,1,1).sel
  var %zeneth.gettop = $did($dname,1,%zeneth.gettopnum)
  var %zeneth.f = $zeneth.r.fserv($1)
  if (None != $1-2) { halt }
  if (($zeneth.r.credit($1) < [ $zeneth.credit(%zeneth.gettop) ] ) && ($zeneth.numcheck(%zeneth.gettop))) { zeneth.error $1 I'm sorry but you don't have enought credit to get that file! }
  if ((%zeneth.gettopnum <= 0) || (%zeneth.gettopnum > 10)) { halt }
  if ($chat($1) != $null) { 
    if (Hawkee isin %zeneth.f) { var %zeneth.c = Top }
    else { var %zeneth.c = Get }
  .msg = $+ [ $1 ] %zeneth.c %zeneth.gettopnum }
}
alias zeneth.gettop {
  if ($chat($1) == $null) { halt }
  if ($dialog(zeneth-Top10- [ $+ [ $1 ] ] ).x != $null) { did -r zeneth-Top10- [ $+ [ $1 ] ] 1 }
  if ( [ $zeneth.r.fserv($1) ] == regular) { halt }
  zeneth.work o $1 Obtaining the Top10 list from $1 $+ .... Please Wait
  write -c %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .sta
  zeneth.writeini $1 Status Top10
  var %zeneth.stype = $zeneth.r.fserv($1)
  if ((panzer isin %zeneth.stype) || (%zeneth.stype == zeneth)) { .msg = $+ $1 top10 | goto end }
  if (%zeneth.stype == Hawkee) { .msg = $+ $1 top | goto end }
  else { zeneth.writeini $1 Status Norm }
  :end
}
alias zeneth.top.view {
  var %zeneth.loop = 1
  var %zeneth.stlines = $lines( [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .sta ] )
  did -r $2 1
  :loop
  if (%zeneth.loop > %zeneth.stlines) { goto end }
  var %zeneth.rep = $chr(32) $+ $chr(44) $+ $chr(32)
  var %zeneth.read = $read -nl [ $+ [ %zeneth.loop ] ] [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .sta ]
  var %zeneth.read = $strip(%zeneth.read))
  if ((10 most downloaded isin %zeneth.read) || (Nr.  Dwnlds Filename  Size isin %zeneth.read) || (GET <NR> isin %zeneth.read) || (Type Top <Number> isin %zeneth.read)) { goto next }
  if (panzer !isin $zeneth.r.fserv($1)) { zeneth.top.addline $2 $replace(%zeneth.read,$chr(160),$chr(32)) }
  else { zeneth.top.panz.addline $2 $replace(%zeneth.read,$chr(160),$chr(32)) }
  :next
  inc %zeneth.loop 1
  goto loop
  :end
  var %zeneth.stlines = $did($2,1).lines
  dialog -t $2 Top [ $+ [ %zeneth.stlines ] ] Files for: $1
}
alias zeneth.top.addline { did -a $1 1 $3- }
alias zeneth.top.panz.addline { did -a $1 1 $4- }
alias zeneth.credit {
  if (($1 !isnum) && ($chr(32) !isin $1) && ($chr(160) !isin $1)) { return $zeneth.r.credit($1) }
  return $zeneth.creditte($1-)
}
alias zeneth.creditte {
  %zeneth.loop3 = $len($1-)
  %zeneth.loop.txt = $1-
  %zeneth.loop.txt = $right(%zeneth.loop.txt, [ $calc( [ $len(%zeneth.loop.txt) ] - [ $pos(%zeneth.loop.txt,credit) ] ) ] )
  if (ratio isin %zeneth.loop.txt) {
    var %zeneth.loop = $calc($pos(%zeneth.loop.txt,ratio) - 1)
    var %zeneth.loop.txt = $left(%zeneth.loop.txt,%zeneth.loop)
    var %zeneth.loop3 = $len(%zeneth.loop.txt)
  }
  :loop
  if ($left(%zeneth.loop.txt,1) isnum) { goto loop2 }
  else {
    if ($left(%zeneth.loop.txt,1) == ~) { var %zeneth.loop.txt = $right(%zeneth.loop.txt,$calc(%zeneth.loop3 - 2)) }
    else { var %zeneth.loop.txt = $right(%zeneth.loop.txt,$calc(%zeneth.loop3 - 1)) }
    var %zeneth.loop3 = $len(%zeneth.loop.txt)
    if ((%zeneth.loop3 <= 0) || (%zeneth.loop3 == $null)) { return Free Credit | goto end }
    goto loop
  }
  :loop2
  if (($right(%zeneth.loop.txt,1) isnum) && (%zeneth.loop.txt isnum)) {
    %zeneth.txt.pos = $calc( [ $pos($1-,%zeneth.loop.txt) ] + [ $len(%zeneth.loop.txt) ] + 2)
    %zeneth.loop.chk = [ $right($left($1-,%zeneth.txt.pos),2) ]
    if (MB isin %zeneth.loop.chk) { return $round( [ $calc( ( [ %zeneth.loop.txt ] * 1000) * 1000) ] ,0) }
    if (KB isin $1-) { return $round( [ $calc( [ %zeneth.loop.txt ] * 1000) ] ,0) }
    else { return %zeneth.loop.txt }
    goto end
  }
  var %zeneth.loop.txt = $left(%zeneth.loop.txt,$calc(%zeneth.loop3 - 1))
  var %zeneth.loop3 = $len(%zeneth.loop.txt)
  if ((%zeneth.loop3 <= 0) || (%zeneth.loop3 == $null)) { return Free Credit | halt }
  goto loop2
  :end
  unset %zeneth.loop*
}

alias zeneth.getlist { if ($chat($1) != $null) { .msg = $+ [ $1 ] !list } }
alias zeneth.ruleread {
  var %zeneth.r = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .rule ]
  if ($exists(%zeneth.r) != $true) { halt }
  clear @ZeNeTh- $+ $1 $+ -Rules
  window -aok0d +l @ZeNeTh- $+ $1 $+ -Rules $zeneth.x($zeneth.d) $zeneth.y($zeneth.d) 522 261 @ZeNeTh.Rules fixedsys
  loadbuf -p @ZeNeTh- $+ $1 $+ -Rules %zeneth.r
  .titlebar @ZeNeTh- $+ $1 $+ -Rules $zeneth.stitlebar(Rules Message for: [ $1 ] )
}
alias zeneth.motdread {
  var %zeneth.r = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .motd ]
  if ($exists(%zeneth.r) != $true) { halt }
  clear @ZeNeTh- $+ $1 $+ -MOTD
  window -aok0d +l @ZeNeTh- $+ $1 $+ -MOTD $zeneth.x($zeneth.d) $zeneth.y($zeneth.d) 522 261 @ZeNeTh.Rules fixedsys
  loadbuf -p @ZeNeTh- $+ $1 $+ -MOTD %zeneth.r
  .titlebar @ZeNeTh- $+ $1 $+ -MOTD $zeneth.stitlebar(Message.Of.The.Day for: [ $1 ] )
}
menu @ZeNeTh.Rules {
  dclick { window -c $active }
  Close Window { window -c $active }
}
alias zeneth.titlebar { return <<<ZeNeTh FileServer Explorer>>> $1- <<<ZeNeTh FileServer Explorer>>> }
alias zeneth.stitlebar { return <<<ZeNeTh>>> $1- <<<ZeNeTh>>> }
