alias zeneth.exp.view {
  if ($dialog($zeneth.exp.dialog($1)).x == $null) { 
    dialog -m $zeneth.exp.dialog($1) zeneth-Explorer 
    var %zeneth.s = $zeneth.r.size($zeneth.d)
    if (%zeneth.s == NoStatus) { zeneth.exp.size $1 Status }
    elseif (%zeneth.s == Compact) { zeneth.exp.size $1 Compact }
  }
  else { zeneth.exp.loadinfo $1 }
  dialog -t $zeneth.exp.dialog($1) $zeneth.titlebar($1)
}
dialog Zeneth-Explorer {
  title "FileServer Explorer"
  size 20 48 520 595
  edit "",141,367.2 122.5 40 20,center,read
  edit "",142,475 122.5 40 20,center,read
  text "Selected of:",140,412.5 125 60 15
  button "",1,45 17.5 80 20,center
  edit "Ratio",2,75 42.5 35 20,center,read
  text "Credit",3,10 20 34 20
  text "Ratio",4,15 45 35 20
  edit "",5,75 67.5 35 20,center
  edit "",6,75 92.5 35 20,center
  text "Max Gets",7,15 72.5 55 20
  text "Max Sends",8,15 95 60 20
  box "FileServ Stats",9,5 2.5 125 115
  box "Directory Stats",10,135 2.5 165 115
  edit "Files",11,170 22.5 55 20,center,read
  edit "Dirs",12,255 22.5 40 20,center,read
  edit "Tagged",13,220 72.5 40 20,center,read
  text "Files",14,140 25 28 20
  text "Dirs",15,227.5 25 25 20
  text "Mask",16,140 50 30 20
  text "Tagged Files",17,140 75 70 20
  button "Yes",18,260 92.5 35 20
  text "Allow Duplicate Files?",19,140 97.5 115 20
  box "AutoSend",20,305 2.5 209 115
  text "AutoSend Status",21,310 22.5 90 20
  button "On",22,400 20 50 20
  button "Path",23,310 45 195 20
  edit "Min Credit",24,377.5 67.5 127.5 20,center
  text "Min. Credit",25,310 72.5 60 20
  edit "Files Autosent",26,390 92.5 115 20,center,read
  text "Files AutoSent",27,310 95 77.5 17.5
  box "Status",28,5 532.5 510 40
  edit "Status",29,10 546.5 500 20,read
  button "Mask",30,170 47.5 125 20
  box "Progress",31,122.5 197.5 267.5 142.5
  edit "",32,275 225 62.5 20,center,read
  text "Files/Directories Counted",33,135 227.5 135 20
  text "Processing:",34,140 255 200 30
  edit "",35,160 285 209 20,read
  list 36,5 147.5 510 360,hide,extsel,hsbar
  button "",37,10 10 10 10,hide,cancel
  combo 41,5 122.5 122.5 150,drop
  combo 43,167.5 122.5 150 150,drop
  button "-&Get-",44,130 122.5 30 22.5
  button "-&Send-",45,320 122.5 37.5 22.5
  combo 42,5 507.5 510 100,drop
  text "%",52,225 310 100 20
  menu "&File",53
  item "&Getlist",46
  item "F&ailed-Files",47
  item break,94
  item "&Chat Window",54
  item "FileServer &Notices",56
  item break,55
  menu "E&xit",67,53
  item "&Exit",68
  item "Exit (&Stop Sends)",69
  item break,70
  item "&Disable Addon",71
  menu "&Extras",72
  item "File &Info",73
  item "Read &File",86
  item break,77
  menu "&Stats",74,72
  item "&Local Stats",75
  item break,76
  item "FileServer's Stats (&You)",78
  item "FileServer's Stats (&FileServe)",79
  item break,80
  item "&Top10 Files",81
  menu "&Rules && Messages",82,72
  item "Read &M.O.T.D",84, disable
  item "Read &Rules",83, disable
  menu "St&op!",88
  menu "All &Sends",89,88
  item "Do it!",99
  menu "All &Gets",90,88
  item "&Do it!",100
  menu "&Refresh",91
  item "&Explorer Window",92
  item "&Current Directory",93
  menu "&View",57
  item "&Full View",58
  item "Full View (No &Status)",59
  item "&Compact View",60
  item "&Minimal View",61
  menu "Se&ttings",62
  item "&Misc. Settings",63
  item "&Script Settings",64
  item break,65
  item "Manually Set &Credit",66
  menu "&Help",95
  item "&Contents",96
  item break,97
  item "&About...",98
}
on *:dialog:zeneth-Exp-*:init:0:{
  zeneth.exp.initiate $dname
  zeneth.exp.cmd zeneth.exp.loadinfo $zeneth.ex
}
alias zeneth.exp.initiate {
  did -b $1 83,84,86,78,79,81
  zeneth.exp.servcheck $dname $zeneth.ex
  did -a $1 41 Selected Files
  did -a $1 41 All Files
  did -a $1 41 Mask Of Files
  did -a $1 41 
  did -a $1 41 Untagg ALL Files
  did -a $1 43 Next $zeneth.r.maxsends($zeneth.ex) Files (AutoSend)
  did -a $1 43 Next N Files (AutoSend)
  did -a $1 43 
  did -a $1 43 Individual File
  did -a $1 42 Navagation
  did -a $1 42 $str($chr(175),83)
  did -a $1 42 Parent Directory
  did -a $1 42 FileServe Root [\]
  did -a $1 42 Path
  did -a $1 42 
  did -a $1 42 Change To HIDDEN Dir
  zeneth.exp.menureset $1 ALL
  did -f $1 36
  zeneth.exp.ref.all $dname
}
on *:dialog:zeneth-Exp-*:edit:5:zeneth.exp.update maxget
on *:dialog:zeneth-Exp-*:edit:6:zeneth.exp.update maxsend
on *:dialog:zeneth-Exp-*:edit:24:zeneth.exp.update mincredit
on *:dialog:zeneth-exp-*:sclick:37:zeneth.exp.cmd zeneth.chopen $zeneth.ex
on *:dialog:zeneth-Exp-*:sclick:1:zeneth.credit.conv $zeneth.ex 1 | if ($dialog(zeneth-Stats- [ $+ [ $zeneth.ex ] ] ).x != $null) { zeneth.stats.ref $zeneth.ex 17 Credit }
on *:dialog:zeneth-Exp-*:sclick:30:zeneth.mask.open $zeneth.ex
on *:dialog:zeneth-Exp-*:sclick:18:zeneth.exp.duptoggle
on *:dialog:zeneth-Exp-*:sclick:22:zeneth.exp.asendtoggle
on *:dialog:zeneth-Exp-*:sclick:23:zeneth.config.misc.open $zeneth.ex
on *:dialog:zeneth-Exp-*:sclick:44:{ 
  if ($did($dname,41) == Mask of Files) { .timer.zeneth.mask. [ $+ [ $dname ] ] 1 0 .zeneth.exp.get other $zeneth.ex $!$?="Mask?" }
  else { zeneth.exp.get other }
}
on *:dialog:zeneth-Exp-*:sclick:42:zeneth.exp.checknav
on *:dialog:zeneth-Exp-*:sclick:45:zeneth.exp.send
on *:dialog:zeneth-Exp-*:sclick:49:zeneth.exp.refresh
on *:dialog:zeneth-Exp-*:sclick:36:zeneth.exp.update select
on *:dialog:zeneth-Exp-*:dclick:36:zeneth.exp.dclick $zeneth.ex $did($did).sel 
on *:dialog:zeneth-Exp-*:menu:46:zeneth.get.getlist $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:47:zeneth.getfail $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:54:zeneth.chat $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:56:{ var %zeneth.d = zeneth-Notice- [ $+ [ $zeneth.ex ] ] | if ($dialog(%zeneth.d).x == $null) { zeneth.notice.open $zeneth.ex } | else { dialog -v %zeneth.d } }
on *:dialog:zeneth-Exp-*:menu:68:zeneth.exit $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:69:zeneth.exit $zeneth.ex S
on *:dialog:zeneth-Exp-*:menu:71:zeneth.exp.disable $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:58:zeneth.exp.size $zeneth.ex Full
on *:dialog:zeneth-Exp-*:menu:59:zeneth.exp.size $zeneth.ex Status
on *:dialog:zeneth-Exp-*:menu:60:zeneth.exp.size $zeneth.ex Compact
on *:dialog:zeneth-Exp-*:menu:61:zeneth.exp.size $zeneth.ex Minimal
on *:dialog:zeneth-Exp-*:menu:63:zeneth.config.misc.open $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:64:zeneth.config.script.open
on *:dialog:zeneth-Exp-*:menu:66:zeneth.exp.cmd zeneth.credit.manual $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:73:zeneth.fileinfo $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:75:zeneth.stats.open $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:92:{ unset %zeneth.view. [ $+ [ $zeneth.ex ] ] | zeneth.exp.loadinfo $zeneth.ex }
on *:dialog:zeneth-Exp-*:menu:93:zeneth.refresh $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:96:zeneth.hlp Zeneth
on *:dialog:zeneth-Exp-*:menu:98:zeneth.about
on *:dialog:zeneth-Exp-*:menu:78:zeneth.stat.getstat $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:79:zeneth.stat.getstat $zeneth.ex Fstats
on *:dialog:zeneth-Exp-*:menu:81:zeneth.gettop $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:87:zeneth.getlist $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:83:zeneth.ruleread $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:84:zeneth.motdread $zeneth.ex
on *:dialog:zeneth-Exp-*:menu:86:{ if ($chat($zeneth.ex) != $null) { zeneth.read.read $zeneth.ex $dname } }
on *:dialog:zeneth-Exp-*:menu:99:zeneth.close.sends $zeneth.ex all
on *:dialog:zeneth-Exp-*:menu:100:zeneth.close.gets $zeneth.ex
alias zeneth.exp.helpmenu {
  did -a $1 $2 96 &Contents
  did -a $1 $2 97 break
  did -a $1 $2 98 &About...
}
alias zeneth.exp.filemenu { did -a $1 $2 133 &Close Window }
alias zeneth.exp.update {
  if ($1 == select) { zeneth.exp.selected $dname $zeneth.ex }
  if ($did($did) isnum) {
    if ($1 == maxsend) { zeneth.writeini $zeneth.ex MaxSends $zeneth.maxs($int($did($did)) , $zeneth.ex) | zeneth.exp.ref $dname maxsends }
    elseif ($1 == maxget) { zeneth.writeini $zeneth.ex MaxGets $zeneth.maxg($int($did($did)) , $zeneth.ex) | var %zeneth.c = [ $zeneth.r.maxgets($zeneth.ex) ] | if (%zeneth.c != $did($dname,$did)) { zeneth.exp.ref $dname maxgets } }
    elseif ($1 == mincredit) { zeneth.writeini $zeneth.ex AsendCredit $int($did($did)) | if ($dialog($zeneth.con).x != $null) { if ($did($zeneth.con,29) == $zeneth.ex) { did -o $zeneth.con 4 1 $did($did) } } }
  }
  else {
    if ($1 == maxsend) { zeneth.exp.ref $dname maxsends }
    elseif ($1 == maxget) { zeneth.exp.ref $dname maxgets }
    elseif ($1 == mincredit) { zeneth.exp.ref $dname asendcredit }
  }
}
alias zeneth.exp.selected {
  var %zeneth.mask = $zeneth.r.mask($2)
  var %zeneth.total = $did($1,36).lines
  %zeneth.s = $did($1,36,0).sel
  if ((%zeneth.s < 0) || (%zeneth.s == $null)) { var %zeneth.s = 0 }
  did -o $1 141 1 %zeneth.s
  did -o $1 142 1 %zeneth.total
}
alias zeneth.exp.duptoggle {
  if ($did($did) == No) { zeneth.writeini $zeneth.ex Dup Yes }
  else { zeneth.writeini $zeneth.ex Dup No }
  if ($dialog($zeneth.con).x != $null) { if ($did($zeneth.con,29) == $zeneth.ex) { zeneth.config.loadsettings } }
  zeneth.exp.ref $dname Lookup Dup
}
alias zeneth.exp.asendtoggle {
  if ($did($did) == On) { zeneth.writeini $zeneth.ex Asend Off }
  else { zeneth.writeini $zeneth.ex Asend On }
  if ($dialog($zeneth.con).x != $null) { if ($did($zeneth.con,29) == $zeneth.ex) { zeneth.config.loadsettings } }
  zeneth.exp.ref $dname Asend
}
alias zeneth.exp.checknav {
  .timer.zeneth.exp.ref. [ $+ [ $zeneth.ex ] ] 1 0 zeneth.exp.menureset $dname
  if ($did($did) == Parent Directory) { zeneth.exp.parent $zeneth.ex }
  if ($did($did) == FileServe Root [\]) { zeneth.exp.root $zeneth.ex }
  if ($did($did) == Path) { zeneth.exp.cmd zeneth.exp.path $zeneth.ex }
  if ($did($did) == Change to HIDDEN Dir) { zeneth.exp.cmd zeneth.exp.hidden $zeneth.ex }
}
alias zeneth.exp.send {
  if ($chat($zeneth.ex) == $null) { halt }
  if ($did(43) == Next N Files (AutoSend)) { .zeneth.exp.cmd zeneth.exp.sendcust $zeneth.ex }
  elseif ($did(43) == Individual File) { zeneth.exp.cmd zeneth.exp.filesend $zeneth.ex }
  elseif (Next isin $did(43)) { zeneth.exp.autosend sendaway $zeneth.ex }
}
alias zeneth.exp.sendcust {
  if ( [ $zeneth.r.maxsends($1) ] <= [ $zeneth.send($1) ] ) { halt }
  var %zeneth.custsend = $$?="Number of Files to Send?"
  if ((%zeneth.custsend !isnum) || (%zeneth.custsend > [ $zeneth.r.maxsends($1) ] )) { var %zeneth.custsend = [ $zeneth.r.maxsends($1) ] }
  if (%zeneth.custsend == 0) { halt }
  zeneth.exp.autosend cust [ %zeneth.custsend ] $1
}
alias zeneth.files {
  var %zeneth.return = $readini -n [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .nfo ] [ $zeneth.rep3($zeneth.curdir($1)) ] Files
  if (%zeneth.return == $null) { return 0 }
  return %zeneth.return
}
alias zeneth.dir {
  var %zeneth.return = $readini -n [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .nfo ] [ $zeneth.rep3($zeneth.curdir($1)) ] Dir
  if (%zeneth.return == $null) { return 0 }
  return %zeneth.return
}
alias zeneth.total { return $readini -n %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .nfo $zeneth.rep3($zeneth.curdir($1)) Total }
alias zeneth.curdir { return $zeneth.r.currentdir($1) }
alias zeneth.curdi { return $zeneth.r.currentdir($zeneth.ex) }
alias zeneth.asenddir {
  if ($zeneth.r.asenddir($1) == $null) { return $zeneth.r.asenddir($zeneth.d) }
  else { return $zeneth.r.asenddir($1) }
}
alias zeneth.tagged {
  if ($exists( [ $zeneth.getdir($1) ] )) { return $lines( [ $zeneth.getdir($1) ] ) }
  else { return 0 }
}
alias zeneth.asendno {
  if ($zeneth.r.asenddir($1) == $null) { var %zeneth.asendno = $zeneth.r.asendno($1) }
  else { var %zeneth.asendno = $zeneth.r.custno($1) }
  if (%zeneth.asendno == $null) { return 0 }
  else { return %zeneth.asendno }
}
alias zeneth.asendtot {
  if ($zeneth.r.asenddir($1) == $null) { var %zeneth.asendtot = $zeneth.r.total($zeneth.d) }
  else { var %zeneth.asendtot = $zeneth.r.total($1) }
  if (%zeneth.asendtot == $null) { return 0 }
  else { return %zeneth.asendtot }
}
alias zeneth.repdir { return $zeneth.rep3($replace($1-,\,)) }
alias zeneth.exp { return $right($1,-11) }
alias zeneth.ex { return $right($zeneth.nam,-11) }
alias zeneth.exp.dialog { return Zeneth-Exp- [ $+ [ $1 ] ] }
alias zeneth.dupstat {
  if ($zeneth.r.dup($1) == $null) { return $zeneth.r.dup($zeneth.d) }
  else { return $zeneth.r.dup($1) }
}
alias zeneth.exp.menureset {
  if ($2 == $null) { did -c $1 42 1 }
  else { if ($2 == ALL) { did -c $1 41,42,43 1 } | else { did -c $1 $2 1 } }
}
alias zeneth.exp.get { 
  var %zeneth.nam = $zeneth.ex
  var %zeneth.dlg = $dname
  if (($did(%zeneth.dlg,41) == $null) && ($1 == $null)) { halt }
  if (($dname == $null) && ($1 == other)) { var %zeneth.filter = $3- | var %zeneth.nam = $2, %zeneth.dlg = $zeneth.exp.dialog($2) }
  elseif (($1 == Other) && ($did(%zeneth.dlg,41) == Untagg ALL Files)) { zeneth.get.clear %zeneth.nam | goto end }
  elseif (($did(%zeneth.dlg,41) == Selected Files) || ($1 != other)) { var %zeneth.tline = $did(%zeneth.dlg,36,0).sel }
  if (($did(%zeneth.dlg,41) != Selected Files) && ($1 == other)) { var %zeneth.tline = [ $zeneth.total(%zeneth.nam) ] }
  else { unset %zeneth.filter }
  var %zeneth.curdir = [ $zeneth.rep3($zeneth.curdir(%zeneth.nam)) ]
  var %zeneth.mask = $zeneth.r.mask(%zeneth.nam)
  if (%zeneth.mask == *.*) { var %zeneth.readmask = [ $zeneth.repcom($zeneth.rep3( [ %zeneth.dir $+ [ $zeneth.rep1(%zeneth.nam) ] $+ $+ - $+ [ $zeneth.repcom($zeneth.repdir($zeneth.curdir(%zeneth.nam))) ] ] )) ] }
  else { var %zeneth.readmask = [ %zeneth.dir $+ [ $zeneth.rep1(%zeneth.nam) ] $+ .msk ] | var %zeneth.tline = $lines(%zeneth.readmask) }
  if (%zeneth.tline == $null) { halt }
  var %zeneth.sline = 1
  :loop
  if (($did(%zeneth.dlg,41) == Selected Files) || ($1 != other)) { var %zeneth.yline = $did($zeneth.nam,36, [ %zeneth.sline ] ).sel }
  if (($did(%zeneth.dlg,41) != Selected Files) && ($1 == other)) { var %zeneth.yline = %zeneth.sline }
  if ( %zeneth.yline == $null) { goto end }
  if (%zeneth.sline > %zeneth.tline ) { goto end }
  if (%zeneth.yline <= 0) { goto kl }
  else { 
    if (%zeneth.curdir == \) { inc %zeneth.yline 1 }
    var %zeneth.name = $read -nl [ $+ [ %zeneth.yline ] ] %zeneth.readmask
    var %zeneth.var = $zeneth.openm(%zeneth.name)
    var %zeneth.name = [ $zeneth.repd($zeneth.getf(%zeneth.name)) ]
    var %zeneth.size = $zeneth.seperate(%zeneth.name)
    var %zeneth.name = $zeneth.rep3($remove( [ %zeneth.name ] , [ $zeneth.seperate( [ %zeneth.name ] ) $+ b ] ))
    if ((%zeneth.filter != $null) && (%zeneth.filter !iswm %zeneth.name)) { goto kl }
    if ((%zeneth.size == nothin) && (%zeneth.name != ..)) { goto kl }
    if (%zeneth.name == ..) { goto kl }
    if (%zeneth.var == y) { goto kl }
    unset %zeneth.chek
    var %zeneth.dup = [ $zeneth.repb($left(%zeneth.name,2)) ]
    if (%zeneth.dup == $null) { var %zeneth.dup = ?? }
    var %zeneth.readfile = %zeneth.dirr $+ files\ $+  [ %zeneth.dup ] $+ .ini
    unset %zeneth.chek
    var %zeneth.p = ?- [Path]->*
    var %zeneth.wild = [ $replace(%zeneth.name,$chr(32),?) $+ [ %zeneth.p ] ]
    if ( [ $exists( [ %zeneth.readfile ] ) ] ) { var %zeneth.chek = $read -w [ $+ [ " $+ [ %zeneth.wild ] $+ " ] ] %zeneth.readfile }
    if (%zeneth.size == 0) { goto kl }
    if (( [ $zeneth.r.dup(%zeneth.nam) ] == no) && (%zeneth.chek != $null)) { goto kl }
    if (2.3b isin [ $zeneth.r.fserv(%zeneth.nam) ] ) { var %zeneth.name = [ $zeneth.dirs($zeneth.rep4(%zeneth.name)) ] }
    write -ds $+ %zeneth.name [ $zeneth.getdir(%zeneth.nam) ]
    write [ $zeneth.getdir(%zeneth.nam) ] [ %zeneth.name ] [ %zeneth.size $+ b ]
    write [ %zeneth.dir $+ [ $zeneth.rep1(%zeneth.nam) ] $+ .fle ] [ %zeneth.name ] [ %zeneth.size $+ b ] [ $zeneth.rep3($zeneth.curdi) ]
    :kl
    inc %zeneth.sline 1
    goto loop
  }
  :end
  zeneth.exp.ref $zeneth.nam lookup tagged
  .timer.zeneth.refresh. [ $+ [ %zeneth.nam ] ] 1 1 zeneth.credref %zeneth.nam
  .timer.zeneth.getstuff. [ $+ [ %zeneth.nam ] ] 1 1 zeneth.getstuff %zeneth.nam
}
alias zeneth.exp.loadinfo {
  if ((%zeneth.view. [ $+ [ $1 ] ] == $zeneth.curdir($1)) && ($did($zeneth.exp.dialog($1),36).lines != 0) && (%zeneth.view.mask. [ $+ [ $1 ] ] == $zeneth.r.mask($1))) { goto view }
  %zeneth.view. [ $+ [ $1 ] ] = $zeneth.curdir($1)
  %zeneth.view.mask. [ $+ [ $1 ] ] = $zeneth.r.mask($1)
  .timer.zeneth.fsview [ $+ [ $1 ] ] off
  zeneth.work c $1
  did -hr $zeneth.exp.dialog($1) 36
  var %zeneth.exp.mask = $zeneth.r.mask($1)
  var %zeneth.load.l1 = 1
  if (%zeneth.exp.mask == *.*) { var %zeneth.load.dir = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir($zeneth.curdir($1))) ] ] | var %zeneth.load.tot = $zeneth.total($1) }
  else { var %zeneth.load.dir = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .msk ] | var %zeneth.load.tot = $calc($lines(%zeneth.load.dir) -1) }
  inc %zeneth.load.tot 1
  var %zeneth.curdir = $zeneth.spacedir($1 , $zeneth.rep3($zeneth.curdir($1)))
  if (($exists(%zeneth.load.dir) == $false) || ($lines(%zeneth.load.dir) == 0)) {
    if ($chat($1) == $null) { if ($zeneth.curdir($1) == \) { dialog -x $zeneth.exp.dialog($1) | halt } | else { zeneth.exp.parent $1 } }
    else { zeneth.refresh $1 }
  }
  %zeneth.check.edir. [ $+ [ $1 ] ] = $zeneth.writedir($1)
  %zeneth.add. [ $+ [ $1 ] ] = [ $zeneth.rep3($zeneth.curdir($1)) ]
  if (%zeneth.add. [ $+ [ $1 ] ] == \) { unset %zeneth.add. [ $+ [ $1 ] ] }
  :loop
  var %zeneth.exp.addline = [ $read [ -nl $+ [ %zeneth.load.l1 ] ] [ %zeneth.load.dir ] ]
  if ($left(%zeneth.exp.addline,1) != f) { var %zeneth.exp.addline = $zeneth.dir.0b(%zeneth.exp.addline) }
  zeneth.exp.pc $1 [ $int($calc((%zeneth.load.l1 / %zeneth.load.tot) * 100)) ] Loading Directory ( $+ %zeneth.load.tot  Files/Directories $+ ): $str($chr(160),2) $zeneth.dir.len(%zeneth.curdir)
  zeneth.exp.addline $1 %zeneth.c %zeneth.exp.addline
  inc %zeneth.load.l1 1
  if (%zeneth.load.l1 > %zeneth.load.tot) { goto view }
  goto loop
  :view
  set -u10 %zeneth.vcheck. [ $+ [ $1 ] ] Check...
  zeneth.exp.savepos $1
  zeneth.exp.selected $zeneth.exp.dialog($1) $1
  zeneth.exp.ref.all $zeneth.exp.dialog($1)
  zeneth.exp.progress hide $zeneth.exp.dialog($1)
  zeneth.exp.dirlist show $zeneth.exp.dialog($1)
  did -f $zeneth.exp.dialog($1) 36 1
  .timer.zeneth. [ $+ [ $1 ] ] 0 10 zeneth.refcred $1
}
alias zeneth.exp.addline {
  if ($2 == d) {
    if (2.3 !isin $zeneth.r.fserv($1)) { goto check }
    if (~ isin %zeneth.add. [ $+ [ $1 ] ] ) {
      var %zeneth.addd = $zeneth.spacedir($1 , [ %zeneth.add. [ $+ [ $1 ] ] ] )
      var %zeneth.addd1 = $zeneth.spacedir($1 , [ %zeneth.addd $+ \ $+ [ $zeneth.rep3($3-) ] ] )
      if (%zeneth.addd1 == $null) { var %zeneth.addd1 = %zeneth.add. [ $+ [ $1 ] ] }
      var %zeneth.check.edir = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir(%zeneth.addd1)) ] ]
    }
    else { 
      :check
      var %zeneth.cdir = $zeneth.curdir($1)
      if (%zeneth.cdir == \) { unset %zeneth.cdir }
      var %zeneth.check.edir = [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir( [ %zeneth.cdir $+ \ $+ [ $zeneth.repcom($zeneth.rep3($3-)) ] ] )) ] ] 
    }
    if ( [ $exists(%zeneth.check.edir) ] ) { var %zeneth.Cache =  Cached  }
    else { var %zeneth.cache =  Un-Cached  }
    if ($3 == ..) { unset %zeneth.cache | var %zeneth.dir.add = .. }
    else { var %zeneth.dir.add = $zeneth.dir.0b($3-) }
    did -a $zeneth.exp.dialog($1) 36 %zeneth.dir.add $+ $zeneth.spaces(%zeneth.dir.add) $+ <DIRECTORY> $+ $zeneth.spaces(<DIRECTORY>) $+ %zeneth.cache
    goto end
  }
  if ($2 == f) {
    var %zeneth.file = $remove($3-, [ $zeneth.seperate($3-) $+ b ] )
    if ( [ $zeneth.r.cacheread($1) ] == Yes) {
      var %zeneth.fleft = [ $zeneth.repb($left($zeneth.rep3(%zeneth.file),2)) ]
      if (%zeneth.fleft == $null) { var %zeneth.fleft = ?? }
      var %zeneth.ffile = [ %zeneth.dirr $+ files\ $+ [ %zeneth.fleft ] $+ .ini ]
      if ($exists(%zeneth.ffile) == $false) { goto not }
      var %zeneth.p = ?- [Path]->*
      var %zeneth.cacheread = $read [ -w $+ [ " $+ [ [ $replace(%zeneth.file,$chr(32),?) ] $+ [ %zeneth.p ] ] $+ " ] ] [ %zeneth.ffile ]
      if (%zeneth.cacheread != $null) { var %zeneth.Cache = Downloaded  | goto disp }
      :not
      var %zeneth.cache = Not-Downloaded 
    }
    :disp
    var %zeneth.size = $zeneth.seperate($3-) Bytes ( $+ $zeneth.sconvert($zeneth.seperate($3-)) $+ )
    did -a $zeneth.exp.dialog($1) 36 %zeneth.file $+ $zeneth.spaces(%zeneth.file) $+ %zeneth.size $+ $zeneth.spaces(%zeneth.size) $+ %zeneth.cache
  }
  :end
}
alias zeneth.exp.status { did -o $1 29 1 $2- }
alias zeneth.exp.progress {
  if ($1 == show) { did -v $2 31,32,33,34,35,52 }
  if ($1 == hide) { did -h $2 31,32,33,34,35,52 }
}
alias zeneth.exp.dirlist {
  if ($1 == show) { did -v $2 36 }
  if ($1 == hide) { did -h $2 36 }
}
alias zeneth.spacedir {
  var %zeneth.spacedir = $readini [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .nfo ] Dirs $2-
  if (%zeneth.spacedir == $null) { return $2- }
  else { return %zeneth.spacedir }
}
alias zeneth.spaces {
  return [ $str($chr(160), [ $calc(35 - [ $len($1-) ] ) ] ) $+ [ $chr(160) ] ]
}
alias zeneth.exp.servcheck {
  var %zeneth.filelist = $zeneth.r.list($2)
  var %zeneth.rules = $zeneth.r.ruleread($2)
  var %zeneth.motd = $zeneth.r.motd($2)
  var %zeneth.type = $zeneth.r.fserv($2)
  if ((SphooServer v1.2 isin %zeneth.type ) || (%zeneth.type == Normal) || (Polaris isin %zeneth.type)) { goto Check2 }
  if (hawkee isin %zeneth.type) { goto FSStats }
  did -e $1 78
  :FSStats
  did -e $1 79,81
  :Check2
  if ((%zeneth.filelist == on) || (%zeneth.rules == yes)) { if (%zeneth.filelist == on) { did -a $1 72 101 break | did -a $1 72 87 Get File-List } | if (%zeneth.rules == yes) { did -e $1 83 } } 
  if (%zeneth.motd == yes) { did -e $1 84 }
  :Check3
  if ((vK Fserver isin %zeneth.type) || (Panzer-V2.3b == %zeneth.type) || (Zeneth isin %zeneth.type)) { Goto Check4 } 
  did -e $1 86
  :Check4
}
alias zeneth.exp.open {
  if ( [ $zeneth.r.lr($1) ] == on) {
    .msg = $+ $1 cd .
    zeneth.writeini [ $1 ] lr off
  }
  if ($2 == d) {
    zeneth.mask.reset $1
    var %zeneth.curdir = $zeneth.repcom($zeneth.rep3($zeneth.curdir($1)))
    if (%zeneth.curdir == \) { unset %zeneth.curdir }
    if ( [ $chat($1) ] != $null) {
      if (2.3 !isin [ $zeneth.r.fserv($1) ] ) { var %zeneth.dirs = $3- | goto dirrs }
      if ((($chr(32) isin $3-) || (~ isin [ %zeneth.curdir ] )) && ($3 != ..)) {
        var %zeneth.d2 = [ [ %zeneth.curdir ] $+ \ $+ [ $zeneth.dirs($3-) ] ]
        var %zeneth.dirs = [ $readini -n [ [ %zeneth.dir ] $+ [ $1 ] $+ .nfo ] Dirs [ %zeneth.d2 ] ]
        var %zeneth.dirs2 = $zeneth.dirs($3-)
        if ((%zeneth.dirs != $3-) || (~ isin %zeneth.curdir)) {
          if (~ isin [ %zeneth.curdir ] ) { %zeneth.curdirr = [ $zeneth.spacedir($1 , [ %zeneth.curdir ] ) ] }
          else { var %zeneth.curdirr = %zeneth.curdir }
          zeneth.writeini $1 SpaceDir %zeneth.curdirr $+ \ $+ [ $lower($3-) ]
          if ((%zeneth.dirs != [ %zeneth.curdirr $+ \ $+ [ $zeneth.rep3($3-) ] ] ) && (~ isin [ %zeneth.dirs2 ] ) && ( [ %zeneth.dirs ]  != $null)) {
            var %zeneth.dirs3 = $right( [ %zeneth.dirs2 ] ,1)
            var %zeneth.dirs2 = $left( [ %zeneth.dirs2 ] ,7)
            inc %zeneth.dirs3 1
            var %zeneth.dirs = %zeneth.dirs2 $+ %zeneth.dirs3
          }
          else { var %zeneth.dirs = %zeneth.dirs2 }
        }
        else { zeneth.remini $1 spacedir }
        if (%zeneth.dirs == $null) { goto dirs }
        else { goto dirrs }
      }
      :dirs
      var %zeneth.dirs = $zeneth.dirs( [ $lower($3-) ] )
      :dirrs
      zeneth.work o $1 Changing to directory [ $zeneth.repcomr($lower($3-)) ] [ $+ .... Please Wait ]
      .msg = $+ $1 cd %zeneth.dirs
    }
    if (%zeneth.curdir == $null) { var %zeneth.curdir = \ }
    unset %zeneth.check
    if (2.3 isin [ $zeneth.r.fserv($1) ] ) { var %zeneth.dirs = $zeneth.dirs($3-) }
    else { var %zeneth.dirs = $3- }
    if ($len(%zeneth.curdir) > 1) {
      if ($lower($3-) != ..) {
        var %zeneth.ccurdf = %zeneth.curdir $+ \ $+ %zeneth.dirs
        zeneth.writeini $1 Currentdir $lower(%zeneth.ccurdf)
      }
      else { zeneth.writeini $1 Currentdir $lower($zeneth.lower($1 , [ %zeneth.curdir ] )) }
    }
    if ($len(%zeneth.curdir) = 1) { zeneth.writeini $1 Currentdir \ $+ $lower(%zeneth.dirs) }
    zeneth.writeini $1 Path $zeneth.curdir($1)
    unset %zeneth.checkk
    var %zeneth.curdir = [ $zeneth.rep3($zeneth.curdir($1)) ]
    var %zeneth.checkk = $zeneth.total($1 , %zeneth.curdir)
    if (%zeneth.checkk != $null) {
      zeneth.writeini $1 Status Norm
      zeneth.exp.loadinfo $1
    }
    else {
      if ( [ $chat($1) ] != $null) { zeneth.writeini $1 Status Checkcd }
      else {
        zeneth.error $1 I'm sorry but I don't have records of that Directory!
        zeneth.exp.parent $1 88
      }
    }
  }
  else { zeneth.exp.get }
}
alias zeneth.nam {
  if ($dname == $null) { return $right($ltimer,-13) }
  else { return $dname }
}
alias zeneth.exp.dclick {
  if ($window( [ $active $+ -Rules ] ).state != $null) { window -c [ $active $+ -Rules ] }
  var %zeneth.mask = $zeneth.r.mask($1)
  if (%zeneth.mask != *.*) { var %zeneth.Explorer = [ $zeneth.readmask($1 , $2) ] }
  else { var %zeneth.Explorer = [ $zeneth.readline($1 , $2) ] }
  if ($dialog( [ zeneth-Getlist- [ $+ [ $1 ] ] ] ).x != $null) { zeneth.get.getlist $1 }
  zeneth.exp.open $zeneth.repcom($1) %zeneth.c $zeneth.dir.0b(%zeneth.Explorer)
}
alias zeneth.readmask { return $read -nl $+ $2 %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ .msk }
alias zeneth.readline { return $read -nl $+ $2 [ $zeneth.repcom($zeneth.rep3( [ [ %zeneth.dir $+ [ $zeneth.rep1($1) ] $+ - $+ [ $zeneth.repcom($zeneth.repdir( %zeneth.view. [ $+ [ $1 ] ] )) ] ] ] )) ] }
alias zeneth.lower {
  var %zeneth.dird = $count($2-,\)
  if (%zeneth.dird <= 1) { %zeneth.curd = \ | goto disp }
  dec %zeneth.dird 1
  var %zeneth.lp = -1
  while ($count($left($2-, [ %zeneth.lp ] ),\) != [ %zeneth.dird ] ) { dec %zeneth.lp 1 }
  var %zeneth.curd = $left($2- , [ %zeneth.lp ] )
  :disp
  return %zeneth.curd
}
alias zeneth.dir.len {
  if ($len($1-) > 33) { return ... $+ $right($1,33) }
  else { return $1- }
}
alias zeneth.path.len {
  if ($len($1-) > 95) { return ... $+ $right($1,95) }
  else { return $1- }
}
alias zeneth.msg.len {
  if ($len($1-) > 60) { return ... $+ $right($1,60) }
  else { return $1- }
}
alias zeneth.credref { zeneth.exp.ref.all $zeneth.exp.dialog($1) }
