alias zeneth.Install.Open { %zeneth.bmp = [ $scriptdirzeneth.bmp ] | if ($dialog(zeneth-Install).x != $null) { dialog -x zeneth-Install } | dialog -m zeneth-Install zeneth-Install }
dialog zeneth-Install {
  title "ZeNeTh FileServer Explorer - Install"
  size -1 -1 368 235
  text "",1,10 172.5 352.5 20
  edit "",2,7.5 195 352.5 20,read
  text "% Done",3,157.5 217.5 147.5 17.5
  button "HIDDEN",4,1 1 1 1,cancel,hide
  icon 5,3 5 360 159,%zeneth.bmp
}
on *:dialog:zeneth-Install:init:0:{ .timer.zeneth.install 1 0 zeneth.inst.check }
alias zeneth.inst.pc {
  if ($1 != 0) { did -o zeneth-Install 2 1 $str(|, [ $int($calc(($1 / 100) * 172)) ] ) }
  did -a zeneth-Install 3 [ $1 % Done ]
}
alias zeneth.inst.status { did -a zeneth-Install 1 $1- }
alias zeneth.inst.exist {
  if ($script(Zen-Exp1.mrc) != $null) { goto true }
  if ($script(Zen-Exp2.mrc) != $null) { goto true }
  if ($script(Zen-Exp3.mrc) != $null) { goto true }
  if ($script(Zen-Exp4.mrc) != $null) { goto true }
  if ($script(Zen-Exp5.mrc) != $null) { goto true }
  if ($script(Zen-Action1.mrc) != $null) { goto true }
  if ($script(Zen-Action2.mrc) != $null) { goto true }
  Return $False
  :True
  Return $true
}
alias zeneth.inst.check {
  if ($zeneth.inst.exist) { goto ask }
  else { goto load }
  :ask
  zeneth.inst.status Uninstall?
  if ($?!="Do You want to UN-INSTALL ZeNeTh FileServer Explorer?") { goto remove }
  zeneth.inst.status Re-Install?
  if ($?!="Do you want to RE-INSTALL ZeNeTh FileServer Explorer?") { goto load }
  goto Cancel
  :load
  if ($?!="Do You want to Install ZeNeTh FileServer Explorer?" != $true) { goto Cancel }
  zeneth.inst.status Loading...
  zeneth.inst.pc 0
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Exp1.mrc
  zeneth.inst.pc 10
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Exp2.mrc
  zeneth.inst.pc 20
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Exp3.mrc
  zeneth.inst.pc 30 
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Exp4.mrc
  zeneth.inst.pc 40
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Exp5.mrc
  zeneth.inst.pc 50
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Action2.mrc
  zeneth.inst.pc 60
  .load -rs [ $shortfn($scriptdir) ] $+ Zen-Action1.mrc
  zeneth.inst.pc 70
  zeneth.inst.status Initializing Script....
  zeneth.inst.initialise
  goto end
  :remove
  dialog -t zeneth-Install ZeNeTh FileServer Explorer - UnInstall
  zeneth.inst.pc 0
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Exp1.mrc
  zeneth.inst.pc 15
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Exp2.mrc
  zeneth.inst.pc 30
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Exp3.mrc
  zeneth.inst.pc 45
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Exp4.mrc
  zeneth.inst.pc 60
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Exp5.mrc
  zeneth.inst.pc 75
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Action1.mrc
  zeneth.inst.pc 90
  .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Action2.mrc
  unset %zeneth.*
  zeneth.inst.pc 100
  zeneth.inst.status Done! You can remove all the files in your [ $mircdir $+ ZeNeTh\ ] Directory
  .timer.zeneth.install0 1 0 .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Install.mrc
  .timer.zeneth.install1 1 0 .unload -rs " $+ [ $scriptdir ] $+ Zen-Install.mrc"
  goto end
  :Cancel
  zeneth.inst.status Installation Cancelled!
  .timer.zeneth.install.close 1 2 dialog -x zeneth-Install
  .timer.zeneth.install0 1 0 .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Install.mrc
  .timer.zeneth.install1 1 0 .unload -rs " $+ [ $scriptdir ] $+ Zen-Install.mrc"
  :end
}
alias zeneth.inst.initialise {
  unset %zeneth.*
  zeneth.inst.status Creating Directories...
  zeneth.inst.pc 75
  set %zeneth.dir $mircdir $+ ZeNeTh\Cache\
  set %zeneth.dirr $mircdir $+ ZeNeTh\
  mkdir $mircdir $+ ZeNeTh
  mkdir %zeneth.dirr $+ Cache
  mkdir %zeneth.dirr $+ Files
  set %zeneth.dirlistt %zeneth.dirr $+ Zeneth-Files.txt
  if (( [ $exists( [ %zeneth.dirr $+ zeneth.dat ] ) ] ) && ( [ $zeneth.r.version($zeneth.d) ] == 5.00)) { if ($?!="Would you like to keep your current settings?") { goto nn1 } }
  elseif (( [ $exists( [ %zeneth.dirr $+ zeneth.dat ] ) ] ) && ( [ $zeneth.r.version($zeneth.d) ] != 5.00)) { if ($?!="Would you like to keep your current settings?") { goto 5 } }
  zeneth.inst.status Setting Script Defaults...
  zeneth.inst.pc 85
  zeneth.writeini $zeneth.d ASend Off
  zeneth.writeini $zeneth.d ASendCredit 40000
  zeneth.writeini $zeneth.d ASendDir <Nothing>
  zeneth.writeini $zeneth.d MaxSends 5
  zeneth.writeini $zeneth.d MaxGets 5
  zeneth.writeini $zeneth.d RuleRead Yes
  zeneth.writeini $zeneth.d FChat Yes
  zeneth.writeini $zeneth.d DRoot Yes
  zeneth.writeini $zeneth.d Aexp Yes
  zeneth.writeini $zeneth.d Dup Yes
  zeneth.writeini $zeneth.d Cacheread Yes
  zeneth.writeini $zeneth.d Splash Yes
  zeneth.writeini $zeneth.d Total 0
  zeneth.writeini $zeneth.d Custno 0
  :5
  zeneth.writeini $zeneth.d Version 5.00
  zeneth.writeini $zeneth.d Access 0
  zeneth.writeini $zeneth.d Notice Yes
  zeneth.writeini $zeneth.d Flush Off
  zeneth.writeini $zeneth.d MOTD Yes
  zeneth.writeini $zeneth.d Active Yes
  :nn1
  zeneth.inst.status Almost Done...
  zeneth.inst.pc 95
  .zeneth.xywhset
zeneth.flush
}
alias zeneth.xywhset {
  zeneth.writeini $zeneth.d X 10
  zeneth.writeini $zeneth.d Y 10
  zeneth.writeini $zeneth.d Size Full
  zeneth.inst.status Done!
  zeneth.inst.pc 100
  .timer.zeneth.install.close 1 0 dialog -x zeneth-Install
  .timer.zeneth.install0 1 0 .unload -rs [ $shortfn($scriptdir) ] $+ Zen-Install.mrc
  .timer.zeneth.install1 1 0 .unload -rs " $+ [ $scriptdir ] $+ Zen-Install.mrc"
}
on *:Load:{
  if ((5.71 > [ $version ] ) || ($bits != 32)) { //echo -s 8,1<<<7,1ZeNeTh FileServer Explorer8,1>>>0,1 I'm sorry but u use at least mIRC 5.7 or greater 8,1<<<7,1ZeNeTh FileServer Explorer8,1>>> | halt }
  zeneth.install.open
}
